require 'gris'
require 'gris/middleware/json_web_token_decoder/version'

module Gris
  class Middleware
    class JsonWebTokenDecoder
      def initialize(app)
        @app = app
      end

      def call(env)
        if env['HTTP_AUTHORIZATION']
          token = parse_header env['HTTP_AUTHORIZATION']
          decoded_token = JWT.decode token, Gris.secrets.hmac_secret
          env['GRIS_JWT_PAYLOAD'] = decoded_token
        end
        @app.call env
      end

      def parse_header(header)
        header.split(' ').last
      end
    end
  end
end
